# -*- coding: utf-8 -*-
# Name:        test polygone
# version:     0.19.1 (1FDCD.587) alpha
# Author:      akzy
# Created:     09.05.2013
# Copyright:   (c) akzy 2013
#-------------------------------------------------------------------------------
#!/usr/bin/env python
import os,sys
from pandac.PandaModules import *
from direct.directbase import DirectStart
from direct.showbase.DirectObject import DirectObject
from random import randint
from panda3d.core import GeomVertexRewriter, GeomVertexWriter, GeomVertexReader
#import  libs.config #
#from lights import *

GeomX   =16                 #кубиков на ось
GeomY   =16
GeomZ   =16
texpx   =16                 #текстур по горизонтали
texpy   =16                 # по вертикали
texsize =8                  #сколько пикселей на текстуру

#texturepath     ='_data/_img/terrain.png'
texturescount   =1
#workdir= os.getcwd()
#sys.path.append(workdir)
class G7():
    def __init__(self):
        self.texfiles   =3
        gvd         =GeomVertexData('name',
                                    GeomVertexFormat.getV3c4t2(),
                                    Geom.UHStatic)
        self.geom       =Geom(gvd)
        prim            =GeomTriangles(Geom.UHDynamic)
        vertex          =GeomVertexWriter(gvd, 'vertex')
        texcoord        =GeomVertexWriter(gvd, 'texcoord')
        color           =GeomVertexWriter(gvd, 'color')
        #self.wr        =GeomVertexRewriter(gvd, 'color')
        self.startcoord =[0,0,0]
        self.objects    =0
        self.name       ="box"
        self.node       =GeomNode(self.name)
        self.cubes      ={}
        self.tex        =[]
        self.state      =0
    def loadtextures(self):
        self.tpath      =[]
        self.tpath.append("img/terrain.png")
        self.tpath.append("img/cu1.png")

    def rew(self,pandaNode):
        #gvd         =GeomVertexData('name', GeomVertexFormat.getV3c4t2(),Geom.UHStatic)
        geom        =pandaNode.geoms[0]
        prim        =GeomTriangles(Geom.UHDynamic)
        vertex      =GeomVertexWriter(gvd, 'vertex')
        texcoord    =GeomVertexWriter(gvd, 'texcoord')
        color       =GeomVertexWriter(gvd, 'color')

        print str( gvd)
        print str(geom)
        print str(prim)
        print str(indexdata)

class G6():
    def __init__(self,name='gnode2'):
        self.tfiles =1      #файлов/списков с текстурами
        self.node   =GeomNode(name)
        self.geoms  =[]
        self.cubes  ={}
        self.tex    =[]
        self.tpath  =[]
        self.tpath.append("img/terrain.png")
        self.tpath.append("img/cu1.png")
        self.state  =0  # 0 -loading
                        # 1 -intro
                        # 3 -main menu
                        # 10-game
                        # 15-in game menu
        self.loadtextures()

    def loadtextures(self):
        gvd         =GeomVertexData('name', GeomVertexFormat.getV3c4t2(),Geom.UHStatic)
        self.geom   =Geom(gvd)
        prim        =GeomTriangles(Geom.UHDynamic)
        vertex      =GeomVertexWriter(gvd, 'vertex')
        texcoord    =GeomVertexWriter(gvd, 'texcoord')
        color       =GeomVertexWriter(gvd, 'color')
        #self.wr     =GeomVertexRewriter(gvd, 'color')

        #tex.setMagfilter(Texture.FTLinearMipmapLinear)
        #tex.setMinfilter(Texture.FTLinearMipmapLinear)
        self.geoms.append({ 'geom':self.geom,
               'prim':prim,
               'vertex':vertex,
               'color':color,
               'texcoord':texcoord,
               'index':0,
               'gvd':gvd})#,
               #'texture':tex
        for i in xrange(0,texturescount):
            #tex         = loader.loadTexture(self.tpath[i])
            self.tex.append(loader.loadTexture(self.tpath[i]))
    def resetcolor(self,id,color):
        # а как попасть с нужный квадрат ?
        #self.geoms[id]['color'].setData4f(color, color, color, 1.0)
        #self.geoms[id]['color'].setData4f(color, color, color, 1.0)
        #self.geoms[id]['color'].setData4f(color, color, color, 1.0)
        #self.geoms[id]['color'].setData4f(color, color, color, 1.0)
        print "resetcolor:not implemented yet"
    def setcolor(self,id,color):
        self.geoms[0]['color'].addData4f(color, color, color, 1.0)
        self.geoms[0]['color'].addData4f(color, color, color, 1.0)
        self.geoms[0]['color'].addData4f(color, color, color, 1.0)
        self.geoms[0]['color'].addData4f(color, color, color, 1.0)

    def ag(self):
        self.geoms
    def fill(self,x,y,z,x2,y2,z2,id,color=0.5):
        #id=1
        i=self.geoms[0]['index']

        if x !=x2:
            self.geoms[0]['vertex'].addData3f(x    ,y  , z)
            self.geoms[0]['vertex'].addData3f(x2   ,y  , z)
            self.geoms[0]['vertex'].addData3f(x2   ,y2 , z2)
            self.geoms[0]['vertex'].addData3f(x    ,y2 , z2)
        else:
            self.geoms[0]['vertex'].addData3f(x    ,y  , z)
            self.geoms[0]['vertex'].addData3f(x2   ,y2 , z)
            self.geoms[0]['vertex'].addData3f(x2   ,y2 , z2)
            self.geoms[0]['vertex'].addData3f(x    ,y  , z2)


        stepx=1.0/texpx
        stepy=1.0/texpy
        ofsx0=stepx*id
        ofsx1=stepx*(id+1)
        if id<texpx:
            ofsy0=1-stepy
            ofsy1=1
        else:
            ofsy0=1-stepy%id
            ofsy1=1-stepy%(id-1)
        self.geoms[0]['texcoord'].addData2f(ofsx0, ofsy0)
        self.geoms[0]['texcoord'].addData2f(ofsx1, ofsy0)
        self.geoms[0]['texcoord'].addData2f(ofsx1, ofsy1)
        self.geoms[0]['texcoord'].addData2f(ofsx0, ofsy1)

        d=i *4

        self.geoms[0]['prim'].addVertices(d, d + 1, d + 2)
        self.geoms[0]['prim'].addVertices(d, d + 2, d + 3)
        self.geoms[0]['index'] += 1

    def close(self):
        for i in xrange(texturescount):
            self.geoms[i]['prim'].closePrimitive()
            self.geoms[i]['geom'].addPrimitive(self.geoms[i]['prim'])
            self.node.addGeom(self.geoms[i]['geom'])
            self.node.setGeomState(i,
                self.node.getGeomState(i).addAttrib(
                    TextureAttrib.make(self.tex[i])))
    def rand(self,a=0,b=0):
        for x in range(0, GeomX):
            self.cubes[x] = {}
            for y in range(0, GeomY):
                self.cubes[x][y] = {}
                for z in range(0, GeomZ):
                    self.cubes[x][y][z] = randint(0, 1)
                    if self.cubes[x][y][z] !=0 :
                        if x-1 not in self.cubes or self.cubes[x-1][y][z] ==0:
                            self.mkleft(x+a*GeomX,y+b*GeomY,z,3)
                        if x+1 not in self.cubes or self.cubes[x+1][y][z] ==0:
                            self.mkright(x+a*GeomX,y+b*GeomY,z,3)

                        if y-1 not in self.cubes or self.cubes[x][y-1][z] ==0:
                            self.mkback(x+a*GeomX,y+b*GeomY,z,3)
                        #if y+1 not in self.cubes or self.cubes[x][y+1][z] ==0:
                        self.mkfront(x+a*GeomX,y+b*GeomY,z,3)

                        if z-1 not in self.cubes or self.cubes[x][y][z-1] ==0:
                            self.mkbottom(x+a*GeomX,y+b*GeomY,z,2)
                        #if z+1 not in self.cubes or self.cubes[x][y][z+1] ==0:
                        self.mktop(x+a*GeomX,y+b*GeomY,z,2)

    def mkbox(self,x,y,z,id=[0,1,2,3,4,5]):
        self.mkback(x,y,z,id[0])
        self.mkleft(x,y,z,id[1])
        self.mkright(x,y,z,id[2])
        self.mkfront(x,y,z,id[3])
        self.mkbottom(x,y,z,id[4])
        self.mktop(x,y,z,id[5])
    def mktop(self,x,y,z,id):
        self.fill(x+1,y+1,z  ,x  ,y  ,z  ,id)#top
    def mkleft(self,x,y,z,id):
        self.fill(x  ,y+1,z-1,x  ,y  ,z  ,id)#left
    def mkright(self,x,y,z,id):
        self.fill(x+1,y  ,z-1,x+1,y+1,z  ,id)#right
    def mkfront(self,x,y,z,id):
        self.fill(x+1,y+1,z-1,x  ,y+1,z ,id)#front
    def mkback(self,x,y,z,id):
        self.fill(x  ,y  ,z-1,x+1,y  ,z  ,id)#back
    def mkbottom(self,x,y,z,id):
        self.fill(x  ,y+1,z-1,x+1,y  ,z-1,id)#bottom
def myNormalize(myVec):                                 # нормализация вектора
    myVec.normalize()
    return myVec

def main():

    print "This is not main file"

    k=G6()
    for a in xrange(0,2):
        for b in xrange(0,2):
            k.rand(a,b)
    k.close()
    kn= render.attachNewNode(k.node)
    kn.setColor(1.,1.,1.,1)
    base.cam.setPos(0,-50,15)
    base.cam.lookAt(15, 15, 0)



    run()
if __name__ == '__main__':
    main()