# -*- coding: utf-8 -*-
# Name          : test polygone
# version       :
# Author        : akzy
# Created       : 05.05.2013
# Copyright     : (c) akzy 2013
#-------------------------------------------------------------------------------
#!/usr/bin/env python
#import  libs.config #
import  os
#from classes import *
#__________main modules_____________________________________
#from direct.gui.OnscreenImage import OnscreenImage
from panda3d.core import *
#___________________________________________________________

from direct.directbase import DirectStart
from direct.showbase.DirectObject import DirectObject
from direct.gui.DirectGui import *
from direct.interval.IntervalGlobal import *
from direct.task.Task import Task
workdir= os.getcwd()
from g6 import *
class Game(DirectObject):
    def __init__(self):

        k=G6()
        for a in xrange(0,1):
            for b in xrange(0,1):
                k.rand(a,b)
        #k.rand(1,0)
        k.close()
        self.cubeRoot= render.attachNewNode(k.node)
        #base.cam.setPos(0,-50,15)
        #base.cam.lookAt(15, 15, 0)

        # Обработчик столкновений "луча" мышки и объектов ______________________
        self.picker = CollisionTraverser()              # создаём traverser
        self.pq     = CollisionHandlerQueue()           # создаём обработчик столкновений
        self.pickerNode = CollisionNode('mouseRay')     # создаём луч столкновений

        self.pickerNP = camera.attachNewNode(self.pickerNode) #

        self.pickerNode.setFromCollideMask(GeomNode.getDefaultCollideMask())
        self.pickerRay =CollisionSegment(0, 0, 0, 1, 1, 1)
        self.pickerNode.addSolid(self.pickerRay)
        self.picker.addCollider(self.pickerNP, self.pq)
        self.mouseTask = taskMgr.add(self.mouseTask, 'mouseTask')
        self.showmenu()

    def mouseTask(self,task):
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse()
            self.pickerRay.setFromLens(base.camNode, mpos.getX(),mpos.getY())
            #self.menutext[4]=str(base.camNode)
            self.picker.traverse(self.cubeRoot)
            #self.menutext[5]=str(self.pq)
            if self.pq.getNumEntries() > 0:
                #self.menutext[2]=str(self.pq.getNumEntries())+" entries"
                self.pq.sortEntries()
                entry = self.pq.getEntry(0)

                (x,y,z) = entry.getIntoNodePath().getParent().getPos()
                self.menutext[3]=str(entry.getSurfacePoint(render))
                self.menutext[4]=str(entry.getSurfaceNormal(render))
            self.menutext[0]=str(mpos.getX())
            self.menutext[1]=str(mpos.getY())

        return task.cont
    def showmenu(self):
        self.menuM = TextNode('menu')                       #
        self.menuM.setFrameColor(0, 0, 0, 1)
        self.menuM.setCardColor(0, 0, 0, 1)
        self.menuM.setCardAsMargin(0.4, 0.4, 0.4, 0.4)
        self.menuM.setCardDecal(True)
        self.memu  = aspect2d.attachNewNode(self.menuM)     #
        self.memu.setScale(0.04)
        self.memu.reparentTo(base.a2dTopLeft)               #
        self.memu.setPos(0, 0, -.5)                         #
        self.menutext=[""]*10

        lbl=self.menutext[0]+"\n"+self.menutext[1]
        self.menuM.setText(lbl)
        taskMgr.doMethodLater(1, self.menutask, 'menu')

    def menutask(self,task):

        lbl  = "x "     +self.menutext[0]
        lbl +="\ny "    +self.menutext[1]
        lbl +="\n "     +self.menutext[2]
        lbl +="\n "     +self.menutext[3]
        lbl +="\n "     +self.menutext[4]
        lbl +="\n "     +self.menutext[5]
        lbl +="\n "     +self.menutext[6]
        self.menuM.setText(lbl)
        task.delayTime = .2
        return task.again

def main():
    print 'workdir %s'  % workdir
    g=Game()
    run()


if __name__ == '__main__':
    main()
